/* Generated automatically by the program `genautomata'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "alias.h"
#include "tree.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "output.h"
#include "insn-attr.h"
#include "diagnostic-core.h"
#include "flags.h"
#include "function.h"
#include "emit-rtl.h"

/* Vector translating external insn codes to internal ones.*/
static const unsigned char inst_pipeline_translate[] ATTRIBUTE_UNUSED = {
    0,     1,     2,     0,     0,     3,     4,     3,     5,     6,
    7};

/* Comb vector for state transitions.  */
static const unsigned char inst_pipeline_transitions[] ATTRIBUTE_UNUSED = {
    8,     7,    20,     4,    14,     2,     1,     0,     3,     9,
   13,     2,     0,     3,     9,     2,     4,    10,     5,     6,
    4,     4,     3,     0,    12,    11,     7,     4,     3,     0,
   10,     9,     8,     5,    13,     6,     8,    10,     7,    12,
   15,    16,    17,    18,    19,     9};

/* Check vector for state transitions.  */
static const unsigned char inst_pipeline_check[] = {
    0,     0,     0,     0,     0,     0,     0,     0,     1,     1,
    1,     3,     4,     1,     1,     1,     2,     2,     2,     5,
    9,     2,     2,     2,     6,     6,     6,     8,     8,     8,
    7,     7,     7,    20,    20,    20,    10,    11,    12,    13,
   14,    15,    16,    17,    18,    19};

/* Base vector for state transitions.  */
static const unsigned char inst_pipeline_base[] = {
    0,     8,    16,     4,     5,    12,    19,    25,    22,    13,
   29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
   28};

/* Vector of min issue delay of insns.  */
static const unsigned char inst_pipeline_min_issue_delay[] ATTRIBUTE_UNUSED = {
    0,     0,     0,     0,     0,     2,    32,     0,     0,     1,
   16,     0,    17,    18,    33,    16,    17,    17,    17,    16,
   68,    68,    65,    16,    51,    51,    48,     0,    34,    34,
   32,     0,    17,    17,    16,     0,    34,    34,    34,    32,
   34,    34,    33,    16,    51,    51,    50,    32,    51,    51,
   49,    16,    68,    68,    66,    32,   136,   136,   136,   128,
  119,   119,   119,   112,   102,   102,   102,    96,    85,    85,
   85,    80,    68,    68,    68,    64,    51,    51,    51,    48,
   68,    68,    64,     0};

/* Vector for locked state flags.  */
static const unsigned char inst_pipeline_dead_lock[] = {
    0,     0,     0,     1,     1,     1,     0,     0,     0,     1,
    1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
    0};

/* Vector translating external insn codes to internal ones.*/
static const unsigned char fpu_pipe_translate[] ATTRIBUTE_UNUSED = {
    0,     0,     0,     0,     0,     0,     0,     0,     1,     2,
    3};

/* Vector for state transitions.  */
static const unsigned char fpu_pipe_transitions[] ATTRIBUTE_UNUSED = {
    0,     2,     1,     0,     1,     3,     3,     2,     2,     3,
    3,     0};

/* Vector of min issue delay of insns.  */
static const unsigned char fpu_pipe_min_issue_delay[] ATTRIBUTE_UNUSED = {
    0,    40,    20};


#define DFA__ADVANCE_CYCLE 10

struct DFA_chip
{
  unsigned char inst_pipeline_automaton_state;
  unsigned char fpu_pipe_automaton_state;
};


const int max_insn_queue_index = 15;

static int
internal_min_issue_delay (int insn_code, struct DFA_chip *chip ATTRIBUTE_UNUSED)
{
  int temp ATTRIBUTE_UNUSED;
  int res = -1;

  switch (insn_code)
    {
    case 0: /* simple_arith */
    case 1: /* simple_arith_2 */
    case 2: /* simple_arith_4 */
    case 3: /* load */
    case 4: /* store */
    case 5: /* branch */
    case 6: /* call */
    case 7: /* flow */

      temp = inst_pipeline_min_issue_delay [(inst_pipeline_translate [insn_code] + chip->inst_pipeline_automaton_state * 8) / 2];
      temp = (temp >> (8 - ((inst_pipeline_translate [insn_code] + chip->inst_pipeline_automaton_state * 8) % 2 + 1) * 4)) & 15;
      res = temp;
      break;

    case 8: /* fp_arith */
    case 9: /* v2fp_arith */
    case 10: /* $advance_cycle */

      temp = fpu_pipe_min_issue_delay [(fpu_pipe_translate [insn_code] + chip->fpu_pipe_automaton_state * 4) / 4];
      temp = (temp >> (8 - ((fpu_pipe_translate [insn_code] + chip->fpu_pipe_automaton_state * 4) % 4 + 1) * 2)) & 3;
      res = temp;

      temp = inst_pipeline_min_issue_delay [(inst_pipeline_translate [insn_code] + chip->inst_pipeline_automaton_state * 8) / 2];
      temp = (temp >> (8 - ((inst_pipeline_translate [insn_code] + chip->inst_pipeline_automaton_state * 8) % 2 + 1) * 4)) & 15;
      if (temp > res)
        res = temp;
      break;


    default:
      res = -1;
      break;
    }
  return res;
}

static int
internal_state_transition (int insn_code, struct DFA_chip *chip ATTRIBUTE_UNUSED)
{
  int temp ATTRIBUTE_UNUSED;

  switch (insn_code)
    {
    case 0: /* simple_arith */
    case 1: /* simple_arith_2 */
    case 2: /* simple_arith_4 */
    case 3: /* load */
    case 4: /* store */
    case 5: /* branch */
    case 6: /* call */
    case 7: /* flow */
      {

        temp = inst_pipeline_base [chip->inst_pipeline_automaton_state] + inst_pipeline_translate [insn_code];
        if (inst_pipeline_check [temp] != chip->inst_pipeline_automaton_state)
          return internal_min_issue_delay (insn_code, chip);
        else
          chip->inst_pipeline_automaton_state = inst_pipeline_transitions [temp];
        return -1;
      }
    case 8: /* fp_arith */
    case 9: /* v2fp_arith */
    case 10: /* $advance_cycle */
      {
        unsigned char _fpu_pipe_automaton_state;

        temp = fpu_pipe_transitions [fpu_pipe_translate [insn_code] + chip->fpu_pipe_automaton_state * 4];
        if (temp >= 3)
          return internal_min_issue_delay (insn_code, chip);
        else
          _fpu_pipe_automaton_state = temp;

        temp = inst_pipeline_base [chip->inst_pipeline_automaton_state] + inst_pipeline_translate [insn_code];
        if (inst_pipeline_check [temp] != chip->inst_pipeline_automaton_state)
          return internal_min_issue_delay (insn_code, chip);
        else
          chip->inst_pipeline_automaton_state = inst_pipeline_transitions [temp];
        chip->fpu_pipe_automaton_state = _fpu_pipe_automaton_state;
        return -1;
      }

    default:
      return -1;
    }
}


static int *dfa_insn_codes;

static int dfa_insn_codes_length;

static void
dfa_insn_code_enlarge (int uid)
{
  int i = dfa_insn_codes_length;
  dfa_insn_codes_length = 2 * uid;
  dfa_insn_codes = XRESIZEVEC (int, dfa_insn_codes,
                 dfa_insn_codes_length);
  for (; i < dfa_insn_codes_length; i++)
    dfa_insn_codes[i] = -1;
}

static inline int
dfa_insn_code (rtx_insn *insn)
{
  int uid = INSN_UID (insn);
  int insn_code;

  if (uid >= dfa_insn_codes_length)
    dfa_insn_code_enlarge (uid);

  insn_code = dfa_insn_codes[uid];
  if (insn_code < 0)
    {
      insn_code = internal_dfa_insn_code (insn);
      dfa_insn_codes[uid] = insn_code;
    }
  return insn_code;
}

int
state_transition (state_t state, rtx insn)
{
  int insn_code;

  if (insn == 0)
    insn_code = DFA__ADVANCE_CYCLE;
  else
    {
      insn_code = dfa_insn_code (as_a <rtx_insn *> (insn));
      if (insn_code > DFA__ADVANCE_CYCLE)
        return -1;
    }
  return internal_state_transition (insn_code, (struct DFA_chip *) state);
}

int
min_issue_delay (state_t state, rtx_insn *insn)
{
  int insn_code;

  if (insn != 0)
    {
      insn_code = dfa_insn_code (insn);
      if (insn_code > DFA__ADVANCE_CYCLE)
        return 0;
    }
  else
    insn_code = DFA__ADVANCE_CYCLE;

  return internal_min_issue_delay (insn_code, (struct DFA_chip *) state);
}

static int
internal_state_dead_lock_p (struct DFA_chip *ARG_UNUSED (chip))
{
  if (inst_pipeline_dead_lock [chip->inst_pipeline_automaton_state])
    return 1/* TRUE */;
  return 0/* FALSE */;
}

int
state_dead_lock_p (state_t state)
{
  return internal_state_dead_lock_p ((struct DFA_chip *) state);
}

int
state_size (void)
{
  return sizeof (struct DFA_chip);
}

static inline void
internal_reset (struct DFA_chip *chip)
{
  memset (chip, 0, sizeof (struct DFA_chip));
}

void
state_reset (state_t state)
{
  internal_reset ((struct DFA_chip *) state);
}

int
min_insn_conflict_delay (state_t state, rtx_insn *insn, rtx_insn *insn2)
{
  struct DFA_chip DFA_chip;
  int insn_code, insn2_code, transition;
  gcc_checking_assert (insn != 0);
  insn_code = dfa_insn_code (insn);
  if (insn_code >= DFA__ADVANCE_CYCLE)
    return 0;
  gcc_checking_assert (insn2 != 0);
  insn2_code = dfa_insn_code (insn2);
  if (insn2_code >= DFA__ADVANCE_CYCLE)
    return 0;
  memcpy (&DFA_chip, state, sizeof (DFA_chip));
  internal_reset (&DFA_chip);
  transition = internal_state_transition (insn_code, &DFA_chip);
  gcc_assert (transition <= 0);
  return internal_min_issue_delay (insn2_code, &DFA_chip);
}

  static const unsigned char default_latencies[] =
    {
        2,   2,   4,   3,   1,   1,   8,   1,
        5,   5,
    };
static int
internal_insn_latency (int insn_code ATTRIBUTE_UNUSED, int insn2_code ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED, rtx_insn *insn2 ATTRIBUTE_UNUSED)
{
  switch (insn_code)
    {
    case 0:
      switch (insn2_code)
        {
        case 0:
          return 1;
        case 1:
          return 1;
        case 2:
          return 1;
        case 3:
          return 1;
        case 4:
          return 1;
        case 5:
          return 1;
        case 6:
          return 1;
        case 7:
          return 1;
        }
      break;
    case 3:
      switch (insn2_code)
        {
        case 0:
          return 2;
        case 1:
          return 2;
        case 2:
          return 2;
        case 3:
          return 2;
        case 4:
          return 2;
        case 5:
          return 2;
        case 6:
          return 2;
        case 7:
          return 2;
        }
      break;
    case 8:
      switch (insn2_code)
        {
        case 4:
          return 4;
        }
      break;
    }
  return default_latencies[insn_code];
}

int
insn_latency (rtx_insn *insn, rtx_insn *insn2)
{
  int insn_code, insn2_code;
  gcc_checking_assert (insn != 0);
  insn_code = dfa_insn_code (insn);
  if (insn_code >= DFA__ADVANCE_CYCLE)
    return 0;
  gcc_checking_assert (insn2 != 0);
  insn2_code = dfa_insn_code (insn2);
  if (insn2_code >= DFA__ADVANCE_CYCLE)
    return 0;
  return internal_insn_latency (insn_code, insn2_code, insn, insn2);
}

static int
internal_maximal_insn_latency (int insn_code ATTRIBUTE_UNUSED)
{
  switch (insn_code)
    {
    case 0: { return 2; }
      break;
    case 3: { return 3; }
      break;
    case 8: { return 5; }
      break;
    }
  return default_latencies[insn_code];
}

int
maximal_insn_latency (rtx_insn *insn)
{
  int insn_code;
  gcc_checking_assert (insn != 0);
  insn_code = dfa_insn_code (insn);
  if (insn_code >= DFA__ADVANCE_CYCLE)
    return 0;
  return internal_maximal_insn_latency (insn_code);
}

void
print_reservation (FILE *f, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  static const char *const reservation_names[] =
    {
      "issue,int",
      "issue,(issue+int),int",
      "issue,(issue+int),(issue+int),(issue+int),int",
      "issue,int",
      "issue,int",
      "d_lock",
      "d_lock*8",
      "d_lock",
      "issue,F0",
      "issue,(issue+F0),F0",
      "nothing"
    };
  int insn_code;

  if (insn == 0)
    insn_code = DFA__ADVANCE_CYCLE;
  else
    {
      insn_code = dfa_insn_code (insn);
      if (insn_code > DFA__ADVANCE_CYCLE)
        insn_code = DFA__ADVANCE_CYCLE;
    }
  fputs (reservation_names[insn_code], f);
}


#if CPU_UNITS_QUERY

int
get_cpu_unit_code (const char *cpu_unit_name)
{
  struct name_code {const char *name; int code;};
  int cmp, l, m, h;
  static struct name_code name_code_table [] =
    {
    };

  /* The following is binary search: */
  l = 0;
  h = sizeof (name_code_table) / sizeof (struct name_code) - 1;
  while (l <= h)
    {
      m = (l + h) / 2;
      cmp = strcmp (cpu_unit_name, name_code_table [m].name);
      if (cmp < 0)
        h = m - 1;
      else if (cmp > 0)
        l = m + 1;
      else
        return name_code_table [m].code;
    }
  return -1;
}

int
cpu_unit_reservation_p (state_t state, int cpu_unit_code)
{
  gcc_assert (cpu_unit_code >= 0 && cpu_unit_code < 0);
  return 0;
}

bool
insn_has_dfa_reservation_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  int insn_code;

  if (insn == 0)
    insn_code = DFA__ADVANCE_CYCLE;
  else
    {
      insn_code = dfa_insn_code (insn);
      if (insn_code > DFA__ADVANCE_CYCLE)
        insn_code = DFA__ADVANCE_CYCLE;
    }

  return insn_code != DFA__ADVANCE_CYCLE;
}


#endif /* #if CPU_UNITS_QUERY */

void
dfa_clean_insn_cache (void)
{
  int i;

  for (i = 0; i < dfa_insn_codes_length; i++)
    dfa_insn_codes [i] = -1;
}

void
dfa_clear_single_insn_cache (rtx_insn *insn)
{
  int i;

  i = INSN_UID (insn);
  if (i < dfa_insn_codes_length)
    dfa_insn_codes [i] = -1;
}

void
dfa_start (void)
{
  dfa_insn_codes_length = get_max_uid ();
  dfa_insn_codes = XNEWVEC (int, dfa_insn_codes_length);
  dfa_clean_insn_cache ();
}

void
dfa_finish (void)
{
  free (dfa_insn_codes);
}

